		String.prototype.startsWith = function (str){return this.indexOf(str) == 0;};
        String.prototype.trim = function(){return (this.replace(/^[\s\xA0]+/, "").replace(/[\s\xA0]+$/, ""))};
        String.prototype.endsWith = function(suffix) {return this.indexOf(suffix, this.length - suffix.length) !== -1;};

        var extension =
        {
            /**
             * Initialize the extension.
             */
            init: function ()
            {
		      var item =
              {
                settings: {
                  type: 'normal',
                  title: browser.i18n.getMessage('mindomo_ctx_send'),
                  contexts: ["all"],
                  onclick: this.onContextMenuAction
                }
              };

              item.id = browser.contextMenus.create(item.settings);
              browser.browserAction.onClicked.addListener(this.onBrowserAction);
            },

            /**
             * Called when the user clicked the browser.
             */
            onBrowserAction:function() {
                // This will take only the active, current tab
                var querying = browser.tabs.query({active: true, currentWindow: true});
                querying.then(function (tab) {
                    var username = MindomoGlobal.getCharPref("username");
                    var password = MindomoGlobal.getCharPref("password");

                    MindomoServer.send(username, password, "1", tab[0].title, tab[0].url, tab[0]);
                }).catch(() => {});
            },

            /**
             * Called when the user clicked the context.
             * @param context
             * @param tab
             */
            onContextMenuAction:function (popupSrc, tab)
            {
                 var username = MindomoGlobal.getCharPref("username");
                 var password = MindomoGlobal.getCharPref("password");
                
                 var text = popupSrc.selectionText;
                 var href = popupSrc.linkUrl;
                 var src  = popupSrc.srcUrl;
                 var type = "0";

				 if(text === undefined ) 
					  text = "";
				  else
					  text = text.trim();
                  if(href === undefined)  
					  href = "";
				  else 
					  href = href.trim();
                  if(src === undefined)
                      src = "";
                  else
                      src = src.trim();

				   // Detect the type
				  if (src != "") type = "2";
				  else if (href != "") type = "1";

                // Send the captured data to the server.
                MindomoServer.send(username, password, type, text,  "1" === type ? href : src, tab);
            },
        };

    extension.init();