
    function showLoginError(message)
    {
        if(message == null) message = "Please provide a valid username and password.";
        $("#errorPass").html(message).show();
    }

    function showLoginSuccess(message)
    {
        setTimeout(function(){window.close()}, 1500);

        $(".small-container").hide();
		$("#loginSuccess").show();
        $("#loginSuccess").html(message);

    }
    /**
     * Save the options given by the user.
     */
    function saveOptions()
    {
        try
        {
             MindomoGlobal.log("Save options.");

             var username = document.getElementById("mindomoUsername").value;
             var pass     = document.getElementById("mindomoPassword").value;

             MindomoGlobal.setCharPref("username", username);
             MindomoGlobal.setCharPref("password", pass);

            $.ajax({
               type:"POST",
               url: MindomoServerUrl,
               timeout: 3000,
               data:
                   "j_username="+encodeURIComponent(username)+
                   "&j_password="+encodeURIComponent(pass),
               context: document.body,
               success: function(data, textStatus)
               {
                   if(data.toString() =="Error:2")
                   {
                       showLoginError();
					   document.getElementById("mindomoPassword").value = '';
                   }
                   else
                   {
                       showLoginSuccess("Successfully saved.");
                   }
               },
               failure: function()
               {
                   showLoginError("Can't connect to the Mindomo Server.");
               },
               error: function(jqXHR, textStatus, errorThrown)
               {
                   showLoginError("Can't connect to the Mindomo Server.");
               }
            });
        }
        catch(e)
        {
            MindomoGlobal.log(e);
            showLoginError("Error occured during saving"+e);
        }
        return false;
    }
		
    /**
     * Load the username/password after the page is loaded.
     */
    window.addEventListener('load', function ()
    {
		$('#errorPass').hide();
			
        var username = MindomoGlobal.getCharPref("username");
        if(username != "Username or Email:" && username !== undefined && username != '') {		
			document.getElementById("mindomoUsername").value = username;
		}
		
		var password = MindomoGlobal.getCharPref("password");
		if(password != "Password:" &&  password != '' && username != "Username or Email:" && username != '' && username !== undefined) {
			document.getElementById("mindomoPassword").value = password;
		}

		$('#mindomoPassword').keypress(function(e) {
			if(e.which == 13) {
				saveOptions();
			}
		});
		$('#saveBtn').on('click', function(){return saveOptions();});
    });
