/************************************************************************************************************
* Add a simple progress indicator to the center of the page.
***********************************************************************************************************/

(function ($) {

  	$.modal = function (options) {
		return _modal(this, options);
	};
	$.modal.open = function () {
		_modal.open();
	};
	$.modal.close = function () {
		_modal.close();
	};
	$.fn.modal = function (options) {
		return _modal(this, options);
	};
    $.fn.injectStyleSheets = function ( e, doc) {
		return _injectStyleSheets(e, doc);
	};
	_modal = function (sender, params) {
		var options = {
			parent: null,
			content: null,
    		width: 200,
            minimumAppearence: 2000,
            style:""
		};
        options = $.extend({}, options, params);
        var start = new Date().getTime();
		this.close = function (force)
        {
            var end     = new Date().getTime();
            var time    = end - start;

            if(time > options.minimumAppearence || force)
            {
                jQuery(options.parent).find("#mindomo_ideagrabber_progressbar").remove();
                return true;
            }
            else
            {
                setTimeout(function (){jQuery(options.parent).find("#mindomo_ideagrabber_progressbar").remove();}, options.minimumAppearence-time);
                return false;
            }
		};
		this.open = function ()
        {
           jQuery(options.parent.getElementsByTagName('body')[0]).append('<div id="mindomo_ideagrabber_progressbar" style="' + options.style +  ';width:'+options.width+'px;height:'+options.height+'px; display: flex; justify-content: center; align-items: center;"></div>');
            $('#mindomo_ideagrabber_progressbar').append(options.content);
		};
		return this;
	};
    /**
     * Inject the stylesheet to the doc.
     * @param e
     * @param doc
     */
    _injectStyleSheets = function ( e, doc)
    {
        for ( var c = 0; c < e.length; c++ ) {
            var b = e[c];
            var d = doc.createElement( "link" );
            d.setAttribute( "rel", "stylesheet" );
            d.setAttribute( "type", "text/css" );
            d.setAttribute( "href", b );
            (doc.head ? doc.head : doc.getElementsByTagName("head")[0]).appendChild( d );
        }
    };
})(jQuery);