if ("undefined" == typeof(MindomoServer)) {
    var MindomoServer = {

        init: function()
        {
        },
        /**
         * Send the data to the server.
         */
        send : function(username, password, type, text, url,  tab)
        {
            // Create the function to show the error
            var showError = function(message)
            {
                var exMessage = "";
                if(message != null && message != undefined) exMessage = "(" + message + ")";
                browser.tabs.sendMessage(tab.id, {command: "show", message: message, type: "error"}).catch(() => {});
                setTimeout(function ()
                    {
                        browser.tabs.sendMessage(tab.id, {command: "hide"}).catch(() => {});
                    },
                    3200);
            };

            var isEmbeddedImageURLRegex = /^\s*data:image\/([a-z]+(;[a-z\-]+\=[a-z\-]+)?)?(;base64)?,[a-z0-9\!\$\&\'\,\(\)\*\+\,\;\=\-\.\_\~\:\@\/\?\%\s]*\s*$/i;
            var isEmbeddedImageURL = function (string) {
                try {
                    return !!string.match(isEmbeddedImageURLRegex);
                } catch (ignored) {
                    return false;
                }
            };

            if ((type == "0" && text == "") || (type != "0" && (url == "" || isEmbeddedImageURL(url))))
            {
                if (isEmbeddedImageURL(url)) {
                    showError("Embedded images are not supported");
                } else {
                    showError("No resource selected");
                }
                return;
            }

            var sending = [];
            if(text != "") sending.push("text");
            if(url != "")
            {
                if(type == "1")
                    sending.push("link");
                else
                    sending.push("image");
            }
            browser.tabs.sendMessage(tab.id, {command:"show", message:sending.join(" and "), type:"info"}).catch(() => {});

            calcServerUrl=MindomoServerUrl;
            $.ajax({
                type:"POST",
                url: calcServerUrl,
                timeout: 3000,
                data:
                "j_username="+encodeURIComponent(username)+
                "&j_password="+encodeURIComponent(password)+
                "&type="+encodeURIComponent(type)+
                "&text="+encodeURIComponent(text)+
                "&url="+encodeURIComponent(url),
                context: document.body,
                success: function(data, textStatus)
                {
                    browser.tabs.sendMessage(tab.id, {command: "hide"}).catch(() => {});
                    if(data.toString() != "Success")
                    {
                        if(data.toString() == "Error:2")
                        {
                            browser.tabs.create({url: "options.html?error=login"});
                        }
                        else
                        {
                            showError();
                        }
                    }
                },
                failure: function()
                {
                    showError();
                },
                error: function(jqXHR, textStatus, errorThrown)
                {
                    showError();
                }
            });
        }
    };
    (function() { this.init(); }).apply(MindomoServer);
};